/* Files */
@font-face {
  font-family: ByteBounce; /* set name */
  src: url(assets/ByteBounce.ttf); /* url of the font */
}



/* General Changes */
:root {
	--text-color: #eaeaea;
}

* {
	margin: 0;
	padding: 0;
	font-family: ByteBounce, -apple-system, BlinkMacSystemFont, "Segoe UI", Roboto, Helvetica, Arial, sans-serif, "Apple Color Emoji", "Segoe UI Emoji", "Segoe UI Symbol";
	color: var(--text-color);
	user-select: none;
}

html, body {
	background-color: #000;
	font-size: 32pt;
}

button {
	user-select: none;
}


/* Title screen */
#titleScreen {
	position: fixed;
	width: calc(100vw + 100px);
	height: calc(100vh + 100px);
	background-color: #000;
	left: -50px;
	top: -50px;
	z-index: 10001;
}
#titleCredits {
	font-size: 36pt;
	color: #333;
	font-weight: 700;
	text-shadow: -1px -1px 0 #ddd, 1px -1px 0 #ddd, -1px 1px 0 #ddd, 1px 1px 0 #ddd;
	text-align: center;
	position: absolute;
	top: 40px;
	left: 0;
	width: 100%;
}
#titleScreen > .areaBackground {
	position: absolute;
	width: 100%;
	height: 100%;
	left: 0;
	top: 0;

	filter: brightness(0.8);
	background-color: #ddd;
	background-image: url(assets/titlescreen.png);
	background-size: 100% 100%;
	z-index: -1;
	animation: circle 40s linear infinite;
}

#titleScreen > h1 {
	font-size: 128pt;
	color: #202020;
	text-shadow: -4px -4px 0 #eee, 4px -4px 0 #eee, -4px 4px 0 #eee, 4px 4px 0 #eee;
	margin-top: 100px;
	text-align: center;
}
#titleScreen > h3 {
	font-size: 48pt;
	color: #404040;
	text-shadow: -2px -2px 0 #eee, 2px -2px 0 #eee, -2px 2px 0 #eee, 2px 2px 0 #eee;
	margin-top: 10px;
	text-align: center;
}

#changelogContainer {
	width: 500px;
	height: 10vh;
	position: fixed;
	left: calc(50vw - 250px);
	top: calc(50vh + 125px);
	background-color: #40404060;
	backdrop-filter: blur(24px);
	border-radius: 20px;
	border: 2px solid #00000020;
	transition: height 1s ease-in-out;
	overflow: hidden;
}
#changelogContainer.open {
	height: max(calc(40vh - 75px), 100px);
}

#changelogButton {
	width: 100%;
	height: 10vh;
	background-color: #00000000;
	border: none;
	border-radius: 20px;
	transition: background-color 0.2s ease-in-out;
	font-size: 48pt;
}
#changelogButton:hover {
	background-color: #00000020;
}
#changelogContent > h4 {
	font-size: 24pt;
	margin-top: 8px;
}
#changelogContent > p {
	transform: scaleY(1.2);
}
#changelogContent {
	box-sizing: border-box;
	overflow-y: scroll;
	padding: 0 16px 16px 16px;
	font-size: 16pt;
	line-height: 0.9;
	height: calc(30vh - 75px);
}

#playButton {
	position: absolute;
	left: calc(50% - 200px);
	top: calc(50% - 75px);
	width: 400px;
	height: 150px;
	font-size: 64pt;
	background-color: #00000070;
	backdrop-filter: blur(24px);
	border: 2px solid #00000020;
	border-radius: 20px;
	transition: background-color 0.3s ease-in-out, transform 0.3s ease-out;
}
#playButton:hover {
	background: #00000078;
	transform: scale(1.02);
}
.fadeOut {
	animation: fadeOut 1s ease-in-out forwards;
}

@keyframes fadeOut {
	0% {
		opacity: 1;
	}

	100% {
		opacity: 0;
	}
}

@keyframes circle {
	from { transform: rotate(0deg) translate(50px, 0) rotate(0deg); }
	to   { transform: rotate(360deg) translate(50px, 0) rotate(-360deg); }
}


/* Dust */
.dust {
	position: absolute;
	width: 8px;
	height: 8px;
	background-color: #909090aa;
	border-radius: 50%;
	pointer-events: none;
	opacity: 1;
	transform: translate(-50%, -50%);
	animation: dustFall 0.9s ease-out forwards;
}

@keyframes dustFall {
	0% {
		opacity: 1;
		transform: translate(-50%, -50%) scale(1);
	}
	20% {
		transform: translate(-50%, -100%) scale(0.9); /* slight lift */
	}
	100% {
		opacity: 0;
		transform: translate(-50%, 150%) scale(0.6); /* fall downward */
	}
}

/* global messaging */
#globalMessageBox {
	position: fixed;
	opacity: 1;
	transform: translateY(-320px);
	left: 25%;
	top: 10px;
	width: 50%;
	background-color: #202020a0;
	border: 2px solid #00000040;
	backdrop-filter: blur(32px);
	z-index: 1003;
	padding: 16px 24px;
	box-sizing: border-box;
	border-radius: 20px;
	max-height: 300px;
	transition: transform 0.2s ease-out;
}
#globalMessageLabel {
	font-size: 32pt;
	text-align: center;
	margin-bottom: 8px;
}
#globalMessageText {
	font-size: 24pt;
	color: #d0d0d0;
}
#globalMessageTime {
	font-size: 20pt;
	color: #b0b0b0;
	position: absolute;
	top: 16px;
	right: 24px;
}
#globalDismissMessage {
	font-size: 20pt;
	color: #b0b0b0;
	position: absolute;
	top: 16px;
	left: 24px;
}
.showGlobal {
	animation: showGlobal 5s ease-in-out forwards;
}
@keyframes showGlobal {
	0% {
		transform: translateY(-320px);
	}
	7% {
		transform: translateY(10px);
	}
	10% {
		transform: translateY(0px);
	}
	90% {
		transform: translateY(0px);
	}
	93% {
		transform: translateY(10px);
	}
	100% {
		transform: translateY(-320px);
	}
}

/* achievement styling */
#achievementNotification {
	position: fixed;
	display: flex;
	flex-direction: row;
	align-items: center;
	padding: 20px;
	box-sizing: border-box;
	height: 200px;
	right: 10px;
	bottom: 10px;
	background-color: #00000060;
	border: 2px solid #40404040;
	backdrop-filter: blur(16px);
	border-radius: 20px;
	transform: translateX(520px);
	z-index: 100001;
}
#achievementNotification.popout {
	animation: achievementPopout 4s ease-in-out forwards;
}
#achievementIconContainer {
	display: flex;
	flex-direction: column;
	align-items: center;
	display: inline-block;
	width: 150px;
	height: 150px;
	padding-right: 20px;
}
#achievementContentContainer {
	display: inline-block;
	width: 300px;
	height: 100%;
}
#achievementIcon {
	width: 100%;
	height: 100%;
}
#achievementName {
	font-size: 24pt;
	font-weight: 700;
	margin-top: 0;
}
#achievementDescription {
	color: #eee;
	font-size: 20pt;
	line-height: 0.8;
}
#achievementReward {
	font-size: 16pt;
	color: #ccc;
	position: absolute;
	bottom: 16px;
}

@keyframes achievementPopout {
	0% {
		transform: translateX(520px);
	}
	7% {
		transform: translateX(-10px);
	}
	10% {
		transform: translateX(0px);
	}
	90% {
		transform: translateX(0px);
	}
	93% {
		transform: translateX(-10px);
	}
	100% {
		transform: translateX(520px);
	}
}


/* Popups */
#usernamePopup {
	position: fixed;
	display: none;
	left: 25%;
	top: 50%;
	transform: translateY(-50%);
	box-sizing: border-box;
	padding: 8px 24px;
	width: 50%;
	min-height: 50px;
	border-radius: 20px;
	background-color: #303030;
	backdrop-filter: blur(24px);
	border: 4px solid #282828;
	z-index: 1004;
	text-align: center;
}
#usernamePopup h2 {
	font-size: 40pt;
	line-height: 0.9;
}
#usernamePopup h4 {
	font-size: 18pt;
	color: #aaa;
	margin-top: 6px;
	margin-bottom: 4px;
	font-weight: 400;
}
#usernamePopup p {
	font-weight: 400;
	font-size: 24pt;
	line-height: 0.8;
	color: #ddd;
	margin-block: 6px 2px;
}
#usernamePopupInput {
	width: 300px;
	padding: 2px 12px;
	font-size: 24pt;
	border-radius: 8px;
	background-color: #444;
	border: 2px solid #555;
}
#usernamePopupInput:focus {
	outline: 1px solid #999;
}
#cancelUsernameButton {
	background-color: #cc4040;
}
#saveUsernameButton {
	background-color: #60cc60;
}
#usernamePopup button {
	width: 100px;
	padding: 4px;
	font-size: 20pt;
	border: none;
	margin-inline: 3px;
	border-radius: 8px;
	transition: filter 0.2s ease-in-out;
}
#usernamePopup button:hover {
	filter: brightness(0.9);
}

/* Settings Styling */
#settings {
	position: fixed;
	display: none;
	left: 50%;
	top: 50%;
	width: 60%;
	height: 80%;
	background-color: #202020aa;
	backdrop-filter: blur(24px);
	border: 2px solid #00000060;
	border-radius: 20px;
	z-index: 1001;
	padding: 10px;
	text-align: center;

	transform: translate(-50%, -50%);
}
#settings h3 {
	padding-top: 5px;
	padding-bottom: 10px;
	font-size: 32pt;
	width: 50%;
	margin: auto;
	text-decoration: underline;
}
#settings span {
	color: #d0d0d0;
}
#settingsContent {
	height: calc(100% - 150px);
	overflow-y: scroll;
	overflow-x: hidden;
}
.settingRow {
	display: flex;
	width: fit-content;
	flex-direction: row;
	align-items: center;
	margin-inline: auto;
	margin-bottom: 10px;
}
#usernameSetting {
	width: 200px;
	padding: 4px 8px;
	border-radius: 10px;
	background-color: #303030;
	border: 2px solid #404040;
	color: #f2f2f2;
	font-size: 20pt;
	margin-left: 20px;
}
#usernameSetting:focus {
	outline: 1px solid #999;
}
#closeSettingsButton {
	position: fixed;
	cursor: pointer;
	background-color: #90909040;
	width: 150px;
	height: 50px;
	bottom: 10px;
	left: 50%;
	border: none;
	font-size: 24pt;
	border-radius: 10px;
	transform: translate(-50%, 0);
}

/* Areas Styling */
#leaderboardArea {
	position: absolute;
	display: none;
	width: 100vw;
	height: 100vh;
	left: 0;
	top: 0;
	background-color: #a38e38;
	background-image: url(assets/trophiesbg.jpg);
	background-size: 100% 100%;
}
#achievementsArea {
	position: absolute;
	display: none;
	width: 100vw;
	height: 100vh;
	left: 0;
	top: 0;
	background-color: #a38e38;
	background-image: url(assets/achievementsbg.jpg);
	background-size: 100% 100%;
}
#area1 {
	position: absolute;
	display: block;
	width: 100vw;
	height: 100vh;
	left: 0;
	top: 0;
	background-color: #909090;
}
#area1 > .areaBackground {
	position: absolute;
	width: 100%;
	height: 100%;
	left: 0;
	top: 0;
	background-image: url(assets/area1bg.jpg);
	background-size: 100% 100%;
}
#area2 {
	position: absolute;
	display: none;
	width: 100vw;
	height: 100vh;
	left: 0;
	top: 0;
	background-color: #909090;
}
#area2 > .areaBackground {
	position: absolute;
	width: 100%;
	height: 100%;
	left: 0;
	top: 0;
	background-image: url(assets/area2bg.jpg);
	background-size: 100% 100%;
}
#area3 {
	position: absolute;
	display: none;
	width: 100vw;
	height: 100vh;
	left: 0;
	top: 0;
	background-color: #909090;
}
#area3 > .areaBackground {
	position: absolute;
	width: 100%;
	height: 100%;
	left: 0;
	top: 0;
	background-image: url(assets/area3bg.jpg);
	background-size: 100% 100%;
}
#area4 {
	position: absolute;
	display: none;
	width: 100vw;
	height: 100vh;
	left: 0;
	top: 0;
	background-color: #909090;
}
#area4 > .areaBackground {
	position: absolute;
	width: 100%;
	height: 100%;
	left: 0;
	top: 0;
	background-image: url(assets/area4bg.jpg);
	background-size: 100% 100%;
}
#skillTreeArea {
	position: absolute;
	display: none;
	width: 3000px;
	height: 3000px;
	left: 0;
	top: 0;
	background-color: #909090;
	background-image: url(assets/skilltreebg.jpg);
	background-size: 1920px 1080px;
}
#infinityArea {
	position: absolute;
	display: none;
	width: 3000px;
	height: 4000px;
	left: 0;
	top: 0;
	background: #121940;
	background: linear-gradient(120deg,rgba(18, 25, 64, 1) 0%, rgba(73, 30, 89, 1) 100%);
}
#infinityArea > .areaBackground {
	position: absolute;
	width: 100%;
	height: 100%;
	left: 0;
	top: 0;
	background-image: url(assets/area1bg.jpg);
	background-size: 100%;
	opacity: 0.1;
}
.darkBG {
	filter: invert(1) contrast(0.95) brightness(0.9);
}

.centerWrapper {
	width: 100%;
	height: 100%;
	display: flex;
	align-items: center;
	justify-content: center;
}

.centerRow {
	display: flex;
	gap: 40px;
}

/* Leaderboards */
.leaderboard {
	width: 400px;
	height: 500px;
	background-color: #20202060;
	border: 1px solid #40404080;
	border-radius: 16px;
	backdrop-filter: blur(12px);
	text-align: center;
	padding: 16px;
	box-sizing: border-box;
	line-height: 0.95;
}

.leaderboard > h3 {
	font-size: 32pt;
	font-weight: 700;
	margin-bottom: 4px;
}

.leaderboard > p {
	font-size: 20pt;
	font-weight: 400;
}

/* Achievements */
#achievementsArea * {
	color: #101010;
}
#achievementsArea > h2 {
	margin-top: 200px;
	font-size: 48pt;
	text-align: center;
}
#achievementsArea > p {
	font-size: 32pt;
	text-align: center;
}

#achievementsContainer {
	display: grid;
	background-color: #00000060;
	backdrop-filter: blur(32px);
	border: 2px solid #20202060;
	padding: 24px;
	width: 60%;
	height: calc(100% - 400px);
	margin: 16px auto;
	border-radius: 24px;

	gap: 8px;

	justify-content: center; /* horizontal centering of the grid */
	align-content: center;   /* vertical centering of the grid */
}
.achievementBox {
	border-radius: 16px;
	padding: 8px;
	box-sizing: border-box;
	background-size: 100% 100%;
	transition: transform 0.2s ease-out;
}
.achievementBox:hover {
	transform: scale(1.05);
}
#achievementHover {
	background-color: #303030a0;
	backdrop-filter: blur(24px);
	border: 2px solid #20202060;
	width: 300px;
	height: 200px;
	position: fixed;
	pointer-events: none;
	border-radius: 16px;
}
#achievementHoverName {
	position: absolute;
	left: 16px;
	top: 16px;
	font-size: 20pt;
	color: #eee;
	font-weight: 700;
	line-height: 0.8;
}
#achievementHoverDescription {
	position: absolute;
	left: 16px;
	top: 40px;
	font-size: 16pt;
	color: #ddd;
	line-height: 0.8;
}
#achievementHoverReward {
	position: absolute;
	left: 16px;
	bottom: 16px;
	font-size: 18pt;
	color: #eee;
	line-height: 0.8;
}

/* Area Selector */
#areaSelect {
	position: fixed;
	right: 10px;
	top: 10px;
	width: 200px;
	border-radius: 20px;
	background-color: #30303040;
	backdrop-filter: blur(8px);
	border: 1px solid #606060a0;
	padding-inline: 12px;
	padding-bottom: 12px;
	padding-top: 4px;
	text-align: center;
}
#areaSelectorsDiv {
	display: flex;
	gap: 8px;
	flex-direction: column;
}
#areaSelect h2 {
	margin: 4px;
	font-size: 32pt;
	font-weight: 400;
}
#areaSelect button {
	background-color: #40404030;
	backdrop-filter: blur(2px);
	border: 1px solid #60606060;
	width: 100%;
	padding-block: 4px;
	border-radius: 10px;
	transition: background-color 0.15s ease-in-out;
	font-size: 18pt;
}
#areaSelect button:hover {
	background-color: #50505038;
}
#areaSelect button:active {
	background-color: #40404030;
}

@keyframes flashButtonYellow {
	0% {
		background-color: #40404030;
	}
	20% {
		background-color: #f0d040a0;
	}
	40% {
		background-color: #40404030;
	}
	60% {
		background-color: #f0d040a0;
	}
	100% {
		background-color: #40404030;
	}
}
.flashAreaSelector {
	animation: flashButtonYellow 3s ease-in-out forwards;
}

/* Switch styling */
/* The switch - the box around the slider */
.switch {
 font-size: 17px;
 position: relative;
 display: inline-block;
 width: 62px;
 height: 35px;
 margin-left: 20px;
}

/* Hide default HTML checkbox */
.switch input {
 opacity: 1;
 width: 0;
 height: 0;
}

/* The slider */
.slider {
 position: absolute;
 cursor: pointer;
 top: 0;
 left: 0;
 right: 0;
 bottom: 0px;
 background: #fff;
 transition: .4s;
 border-radius: 30px;
 border: 1px solid #ccc;
}

.slider:before {
 position: absolute;
 content: "";
 height: 1.9em;
 width: 1.9em;
 border-radius: 16px;
 left: 1.2px;
 top: 0;
 bottom: 0;
 background-color: white;
 box-shadow: 0 2px 5px #999999;
 transition: .4s;
}

input:checked + .slider {
 background-color: #5fdd54;
 border: 1px solid transparent;
}

input:checked + .slider:before {
 transform: translateX(1.5em);
}


/* Settings Div */
#settingsButtonDiv {
	position: fixed;
	top: 8px;
	left: 8px;
}

#settingsButton {
	border: 1px solid #606060a0;
	background-color: #40404080;
	backdrop-filter: blur(8px);
	padding: 8px 16px;
	border-radius: 8px;
	font-size: 20pt;
	transition: background-color 0.15s ease-in-out;
}
#settingsButton:hover {
	background-color: #40404060;
}
#settingsButton:active {
	background-color: #40404040;
}

/* Clicker Styling */
.clickNotification {
	color: #00000050;
	position: absolute;
	top: 50%;
	left: 50%;
	font-size: 48pt;
	transform: translate(-50%, -50%);
	pointer-events: none;
}

/* Stats Display */
#stats {
	position: fixed;
	display: flex;
	flex-direction: column;
	align-items: center;
	width: 100%;
	padding: 8px;
	/*background-color: #30303080;
	backdrop-filter: blur(8px);
	border: 1px solid #606060a0;*/
	border-radius: 10px;
	left: 0;
	top: 5px;
	font-size: 28pt;
	line-height: 0.85;
	pointer-events: none;
}

#stats * {
	text-shadow: -1px -1px 0 #ddd, 1px -1px 0 #ddd, -1px 1px 0 #ddd, 1px 1px 0 #ddd;
	color: #202328;
}

/* Upgrades Stuff */
.upgradeTable {
	position: absolute;
	left: 0;
	width: 100%;
	bottom: 80px;
	padding-inline: 40px;
	box-sizing: border-box;

	display: grid;
	grid-template-columns: repeat(3, 1fr);
	grid-template-rows: repeat(2, 100px);
	pointer-events: none;
	gap: 10px;
}

#area4 .upgradeTable {
	bottom: 30px;
}

.upgrade {
	margin: 6px;
	font-size: 24pt;
	cursor: pointer;

	border-radius: 20px;
	backdrop-filter: blur(16px);
}

#area1 .upgrade {
	background-color: #463f9180;
	border: 1px solid #6059b1a0;
	transition: background-color 0.15s ease-in-out;
	
}
#area1 .upgrade:hover {
	background-color: #463f9170;
}
#area1 .upgrade:active {
	background-color: #463f9180;
}

#area2 .upgrade {
	background-color: #56c08a80;
	border: 1px solid #60d499a0;
	transition: background-color 0.15s ease-in-out;
}
#area2 .upgrade:hover {
	background-color: #56c08a60;
}
#area2 .upgrade:active {
	background-color: #56c08a80;
}

#area3 .upgrade {
	background-color: #ee6e7d80;
	border: 1px solid #f28794a0;
	transition: background-color 0.15s ease-in-out;
}
#area3 .upgrade:hover {
	background-color: #ee6e7d60;
}
#area3 .upgrade:active {
	background-color: #ee6e7d80;
}

#area4 .upgrade {
	background-color: #f7ce5d80;
	border: 1px solid #f7ce5da0;
	transition: background-color 0.15s ease-in-out;
}
#area4 .upgrade:hover {
	background-color: #f7ce5d60;
}
#area4 .upgrade:active {
	background-color: #f7ce5d80;
}

@keyframes bounceUp {
	0% {
		transform: translateY(0);
	}
	50% {
		transform: translateY(-4px);
	}
	100% {
		transform: translateY(-3px);
	}
}
@keyframes bounceDown {
	0% {
		transform: translateY(-3px);
	}
	50% {
		transform: translateY(1px);
	}
	100% {
		transform: translateY(0px);
	}
}
.upgrade {
	transition: transform 0.5s ease-in-out;
	box-shadow: 2px 4px 4px #00000030;
	pointer-events: all;
}
.upgrade:hover {
	animation: bounceUp 0.3s ease-in-out forwards;
}
.upgrade:active {
	animation: bounceDown 0.3s ease-in-out forwards;
}

/* Skill Tree */
#skillResetButton {
	position: absolute;
	width: 400px;
	height: 300px;
	padding: 32px;
	font-size: 32pt;
	left: calc(50vw - 200px);
	top: 200px;
	background-color: #15151560;
	border: 1px solid #70707080;
	border-radius: 30px;
	backdrop-filter: blur(32px);
	transition: background-color 0.2s ease-out, transform 0.2s ease-out;
	box-shadow: 0px 0px 8px #00000040;
}
#skillResetButton:hover {
	background-color: #15151570;
	transform: scale(1.02);
}
#skillResetButton:active {
	background-color: #15151560;
	transform: scale(1);
}

.skillUpgrade {
	width: 150px;
	height: 150px;
	border-radius: 15px;
	background-color: #30303050;
	border: 1px solid #80808080;
	backdrop-filter: blur(16px);
	padding-inline: 4px;
	font-size: 16pt;
	cursor: default;
}
.skillUpgrade.hidden {
	display: none;
}
.skillUpgrade.bought {
	transition: background-color 0.2s ease-in-out, transform 0.2s ease-in-out, color 1s ease-in-out;
	color: #e0e0e0;
	backdrop-filter: blur(24px);
}
.skillUpgrade.unlocked {
	cursor: pointer;
	box-shadow: 0px 0px 16px #dddddd80;
	background-color: #30303050;
	backdrop-filter: blur(18px);
	transition: background-color 0.2s ease-in-out, transform 0.2s ease-in-out;
}
.skillUpgrade.unlocked:hover {
	background-color: #30303070;
	transform: scale(1.05);
}
.skillUpgrade.branch {
	color: #eaeaea90;
	background-color: #30303020;
	backdrop-filter: blur(12px);
}

/* Infinity Stuff */
#infinityStat {
	color: #111;
	text-shadow: -1px -1px 0 #ddd, 1px -1px 0 #ddd, -1px 1px 0 #ddd, 1px 1px 0 #ddd;
	position: absolute;
	left: 0;
	width: 100%;
	text-align: center;
	top: 500px;
	width: 100vw;
	font-size: 64pt;
}
#infinityDisclaimer {
	color: #eeeeee90;
	position: absolute;
	left: 0;
	width: 100%;
	text-align: center;
	top: 615px;
	width: 100vw;
	font-size: 24pt;
}

#breakInfinityBar {
	position: absolute;
	left: 25vw;
	top: 650px;
	width: 50vw;
	height: 40px;
	border-radius: 20px;
	background-color: #202020a0;
	backdrop-filter: blur(24px);
	z-index: 1;
}
#breakInfinityLabel {
	position: relative;
	width: 100%;
	height: 100%;
	text-align: center;
	align-content: center;
	z-index: 3;
}
#breakInfinityProgressBar {
	position: absolute;
	left: 0;
	top: 0;
	width: 50%;
	height: 40px;
	border-radius: 20px;
	background-color: #aa50ee;
	z-index: 2;
}

#infinityTreeArea {
	position: absolute;
	top: 800px;
	left: 50px;
	width: 1500px;
	height: calc(100% - 50vw);
}

#infinityResetButton {
	position: absolute;
	width: 400px;
	height: 300px;
	padding: 32px;
	font-size: 64pt;
	left: 50vw;
	top: 200px;
	transform: translate(-50%, 0%);
	background-color: #15151560;
	border: 1px solid #70707080;
	border-radius: 30px;
	backdrop-filter: blur(12px);
	transition: background-color 0.1s ease-in-out, transform 0.15s ease-in-out;
	/*box-shadow: 0px 0px 32px #000000f0;*/
}
#infinityResetButton .innerText {
	text-shadow: -2px -2px 0 #ff0088, 2px -2px 0 #aa00ff, -2px 2px 0 #aa00ff, 2px 2px 0 #ff0088;
	color: #000;
}
#ipReward {
	position: absolute;
	left: 0;
	top: calc(50%+32px);
	font-size: 24pt;
	font-weight: 400;
	color: #eeeeeea0;
	width: 100%;
	text-align: center;
}
#infinityResetButton:hover {
	background-color: #15151570;
	animation: infinityHover 1s ease-out forwards, bounceUpInfinity 0.5s ease-in-out forwards;
}
#infinityResetButton:active {
	background-color: #15151560;
	animation: infinityHover 1s ease-out forwards, bounceDownInfinity 0.3s ease-in-out forwards;
}

@keyframes infinityHover {
	0% {
		box-shadow: 0px 0px 0px #ffffff40;
	}
	100% {
		box-shadow: 0px 0px 32px #ffffff40;
	}
}
@keyframes bounceUpInfinity {
	0% {
		transform: translate(-50%, 0);
	}
	50% {
		transform: translate(-50%, -12px);
	}
	100% {
		transform: translate(-50%, -9px);
	}
}
@keyframes bounceDownInfinity {
	0% {
		transform: translate(-50%, -9px);
	}
	50% {
		transform: translate(-50%, 3px);
	}
	100% {
		transform: translate(-50%, 0px);
	}
}

.infinityUpgrade {
	width: 250px;
	height: 180px;
	border-radius: 15px;
	background-color: #30303050;
	border: 1px solid #80808080;
	backdrop-filter: blur(24px);
	padding-inline: 8px;
	font-size: 16pt;
	cursor: default;
	transition: background-color 0.15s ease-in-out, color 0.5 ease-in-out;
}
.infinityUpgrade * {
	box-sizing: border-box;
}
.infinityUpgrade.hidden {
	display: none;
}
.infinityUpgrade.bought {
	transition: background-color 0.2s ease-in-out, transform 0.2s ease-in-out, color 1s ease-in-out;
	color: #e0e0e0;
	backdrop-filter: blur(32px);
	transform: scale(0.95);
}
.infinityUpgrade.unlocked {
	cursor: pointer;
	box-shadow: 0px 0px 16px #dddddd40;
	background-color: #30303050;
	backdrop-filter: blur(24px);
	transition: background-color 0.2s ease-in-out, transform 0.2s ease-in-out;
}
.infinityUpgrade.unlocked:hover {
	background-color: #30303070;
	transform: scale(1.05);
}
.infinityUpgrade.branch {
	color: #eaeaea90;
	background-color: #30303020;
	backdrop-filter: blur(12px);
}
.infinityUpgrade.branch * {
	opacity: 0.5;
}

/* name */
.infinityUpgrade h3 {
	position: absolute;
	top: 8px;
	left: 0;
	width: 100%;
	font-size: 20pt;
	font-weight: 700;
	color: #eee;
}
/* description */
.infinityUpgrade p {
	position: absolute;
	top: 50%;
	left: 0;
	width: 100%;
	transform: translateY(-50%);
	font-size: 16pt;
	font-weight: 400;
	padding-inline: 16px;
	line-height: 0.85;
	color: #ddd;
}
/* cost */
.infinityUpgrade h4 {
	position: absolute;
	bottom: 8px;
	left: 0;
	width: 100%;
	font-size: 18pt;
	font-weight: 700;
	color: #ddd;
}

#screenOverlay {
	display: block;
	width: 100vw;
	height: 100vw;
	position: fixed;
	pointer-events: none;
	top: 0;
	left: 0;
	z-index: 10000;
}
.playFlash {
	animation: flashBlack 5s ease-out forwards;
}
@keyframes flashBlack {
	0% {
		background-color: #00000000;
	}
	2% {
		background-color: #000000ff;
	}
	10% {
		background-color: #000000ff;
	}
	100% {
    background-color: #00000000;
	}
}

/* Minigames */
.minigameCanvas {
	display: none;
	width: 100%;
	height: 100%;
	background-color: #00000020;
	backdrop-filter: blur(16px);
	border: none;
	border-radius: 8px;
	overflow: hidden;
	margin-top: 10px;
}

#gameDiv {
	text-align: center;
	position: absolute;
	left: 1600px;
	top: 1400px;
	width: 1000px;
	overflow: hidden;
}
#gameDiv h2 {
	font-size: 48pt;
	text-align: center;
}
.minigameButton {
	display: block;
	background-color: #00000040;
	backdrop-filter: blur(16px);
	border: 2px solid #20202060;
	border-radius: 8px;
	padding: 4px;
	width: 400px;
	font-size: 16pt;
	margin: 8px auto;
	transition: background-color 0.2s ease-in-out;
}
.minigameButton:hover {
	background-color: #00000030;
}
.minigameButton:active {
	background-color: #00000040;
}

/* Infinity Generators */
#infinityGeneratorsContainer {
	position: absolute;
	left: 1600px;
	top: 200px;

	width: 1000px;
	height: 1000px;
}

#infinityPointsStat {
	color: #e978eb;
	position: absolute;
	left: 0;
	width: 100%;
	text-align: center;
	top: 560px;
	width: 100vw;
	font-size: 48pt;
}
#infinityPowerStat {
	color: #f9c87b;
	text-align: center;
	font-size: 48pt;
}

#generatorUpgrades {
	display: flex;
	width: fit-content;
	margin: 40px auto;
	flex-direction: row;
	gap: 20px;
}

#generatorUpgrades button {
	width: 400px;
	height: 150px;
	border-radius: 20px;
	padding: 24px;
	box-sizing: border-box;
	background-color: #30303090;
	border: 1px solid #80808080;
	backdrop-filter: blur(8px);
	transition: background-color 0.15s ease-in-out;
}
#generatorUpgrades button:hover {
	background-color: #30303060;
	animation: bounceUp 0.3s ease-out forwards;
}
#generatorUpgrades button:active {
	background-color: #30303090;
	animation: bounceDown 0.3s ease-out forwards;
}
#generatorUpgrades button .description {
	font-size: 24pt;
}
#generatorUpgrades button .cost {
	margin-top: 10px;
	font-size: 20pt;
	color: #d0d0d0;
}


#infinityPowerUpgrades {
	display: grid;
	width: fit-content;
	margin: 40px auto;
	gap: 20px;
	grid-template-columns: repeat(2, 1fr);
	grid-template-rows: repeat(2, 1fr);
}

#infinityPowerUpgrades button {
	width: 250px;
	height: 150px;
	border-radius: 20px;
	padding: 16px;
	box-sizing: border-box;
	background-color: #30303090;
	border: 1px solid #80808080;
	backdrop-filter: blur(8px);
	transition: background-color 0.15s ease-in-out;
}
#infinityPowerUpgrades button:hover {
	background-color: #30303060;
	animation: bounceUp 0.3s ease-out forwards;
}
#infinityPowerUpgrades button:active {
	background-color: #30303090;
	animation: bounceDown 0.3s ease-out forwards;
}
#infinityPowerUpgrades button .description {
	font-size: 24pt;
}
#infinityPowerUpgrades button .cost {
	margin-top: 10px;
	font-size: 20pt;
	color: #d0d0d0;
}


/* Rebirth Stuff */
.rebirthDiv {
	position: absolute;
	left: 0;
	width: 100%;
	height: 80px;
	bottom: 0px;
	padding: 15px;
	box-sizing: border-box;
	display: flex;
	flex-direction: column;
	align-items: center;
	pointer-events: none;
}

#rebirthButton1 {
	width: 50%;
	height: 100%;
	font-size: 24pt;

	cursor: pointer;
	background-color: #4960a680;
	border: 1px solid #5671c0a0;
	border-radius: 15px;
	backdrop-filter: blur(16px);
	transition: background-color 0.15s ease-in-out;
	pointer-events: all;
}
#rebirthButton1:hover {
	background-color: #4d66b280;
}
#rebirthButton1:active {
	background-color: #4960a680;
}

#rebirthButton2 {
	width: 50%;
	height: 100%;
	font-size: 24pt;

	cursor: pointer;
	background-color: #75d45f80;
	border: 1px solid #72d95ba0;
	border-radius: 15px;
	backdrop-filter: blur(16px);
	transition: background-color 0.15s ease-in-out;
	pointer-events: all;
}
#rebirthButton2:hover {
	background-color: #75d45f88;
}
#rebirthButton2:active {
	background-color: #75d45f80;
}

#rebirthButton3 {
	width: 50%;
	height: 100%;
	font-size: 24pt;

	cursor: pointer;
	background-color: #b0608080;
	border: 1px solid #b06080a0;
	border-radius: 15px;
	backdrop-filter: blur(16px);
	transition: background-color 0.15s ease-in-out;
	pointer-events: all;
}
#rebirthButton3:hover {
	background-color: #b0608088;
}
#rebirthButton3:active {
	background-color: #b0608080;
}